//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  White
#property indicator_color2  Red
#property indicator_color3  Red

//
//
//
//
//

extern string TimeFrame  = "Current time frame";
extern int    MaPeriod   = 6;
extern int    MaMode     = MODE_EMA;
extern int    MaPrice    = PRICE_CLOSE;
extern int    AtrPeriod = 15;
extern double KATR       = 2;
extern int    Shift      = 1;


//
//
//
//
//

double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
  SetIndexBuffer(0,MovingBuffer);
  SetIndexBuffer(1,UpperBuffer);
  SetIndexBuffer(2,LowerBuffer);
  
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
      timeFrame         = stringToTimeFrame(TimeFrame);
      SetIndexShift(0,Shift * timeFrame/Period()); 
      SetIndexShift(1,Shift * timeFrame/Period()); 
      SetIndexShift(2,Shift * timeFrame/Period()); 
         
     IndicatorShortName(timeFrameToString(timeFrame)+" Starc Bands"); 
return(0);
}

int deinit() {  return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { MovingBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for (int i=limit; i>=0; i--) 
     {
        MovingBuffer[i] = iMA(NULL,0,MaPeriod,Shift,MaMode,MaPrice,i);
        UpperBuffer[i]  = MovingBuffer[i] + (KATR * iATR(NULL,0,AtrPeriod,i));
        LowerBuffer[i]  = MovingBuffer[i] - (KATR * iATR(NULL,0,AtrPeriod,i));
     }
     return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         MovingBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMode,MaPrice,AtrPeriod,KATR,Shift,0,y);
         UpperBuffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMode,MaPrice,AtrPeriod,KATR,Shift,1,y);
         LowerBuffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMode,MaPrice,AtrPeriod,KATR,Shift,2,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

  
  